function varargout = dipro(varargin)
% DIPRO MATLAB code for dipro.fig
%      DIPRO, by itself, creates a new DIPRO or raises the existing
%      singleton*.
%
%      H = DIPRO returns the handle to a new DIPRO or the handle to
%      the existing singleton*.
%
%      DIPRO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIPRO.M with the given input arguments.
%
%      DIPRO('Property','Value',...) creates a new DIPRO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before dipro_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to dipro_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help dipro

% Last Modified by GUIDE v2.5 23-Feb-2016 19:14:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dipro_OpeningFcn, ...
                   'gui_OutputFcn',  @dipro_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before dipro is made visible.
function dipro_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to dipro (see VARARGIN)

% Choose default command line output for dipro
handles.output = hObject;

% move GUI to the center
movegui(gcf,'center');

% clear command window
clc

% save handles to mainGui and functions into root memory
setappdata(0,'handles_mainGui',gcf)                 % get handles to main GUI
% setappdata(gcf, 'handles_updateAxes', @updateAxes)  % get handles to updateAxes function

% add path to other folders
addpath(fullfile(pwd,'functions'))
addpath(fullfile(pwd,'files'))
addpath(fullfile(pwd,'input'))
addpath(fullfile(pwd,'output'))

% initiate the variables
run initiateVariables

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes dipro wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = dipro_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

% load the new file
[inputFilename, inputPath] = uigetfile({'*.*'},'File Selector',[pwd,'/input']);
plottingData(1).nDiagrams = plottingData(1).nDiagrams+1;
plottingData(1).currentDiagram = plottingData(1).nDiagrams;
plottingData(1).nDiagramsChanged = true;
plottingData(1).makeSampling = false;
plottingData(1).justAdjusted = true;
plottingData(1).makeSampling = true;
plottingData(1).shapeChanged = false;

% set the new diagram according to previous one and update GUI
plottingData(1).fileNames{plottingData(1).nDiagrams} = extractExtension(inputFilename);
set(handles.listbox1,'String',plottingData(1).fileNames);
set(handles.listbox1,'Value',plottingData(1).currentDiagram);
plottingData(plottingData(1).currentDiagram).colX = str2double(get(handles.edit4,'String'));
plottingData(plottingData(1).currentDiagram).colY = str2double(get(handles.edit5,'String'));
plottingData(plottingData(1).currentDiagram).multiplierX = str2double(get(handles.edit6,'String'));
plottingData(plottingData(1).currentDiagram).multiplierY = str2double(get(handles.edit7,'String'));
plottingData(plottingData(1).currentDiagram).lineColor = ...
    [str2double(get(handles.edit1,'String')),str2double(get(handles.edit2,'String')),str2double(get(handles.edit3,'String'))];
plottingData(plottingData(1).currentDiagram).lineTypeNumber = get(handles.listbox2,'Value');
switch plottingData(plottingData(1).currentDiagram).lineTypeNumber
    case 1
        plottingData(plottingData(1).currentDiagram).lineType = '-';
    case 2
        plottingData(plottingData(1).currentDiagram).lineType = '--';
    case 3
        plottingData(plottingData(1).currentDiagram).lineType = '-.';
    case 4
        plottingData(plottingData(1).currentDiagram).lineType = ':';
end
plottingData(plottingData(1).currentDiagram).smoothing = 1e-6;
set(handles.slider1,'Value',1e-6);

% work with the loaded data
A = importdata([inputPath,inputFilename]);
A = strrep(A,':','');
A = cell2mat(A);
plottingData(plottingData(1).currentDiagram).originalData = str2num(A);
if plottingData(1).currentDiagram == 1
    plottingData(1).samplingDensity = size(A,1);
    set(handles.edit8,'String',num2str(plottingData(1).samplingDensity))
end
plottingData(plottingData(1).currentDiagram).unSampledData =...
                [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colX),...
                plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colY)];
            
setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).nDiagramsChanged = true;

for i = plottingData(1).currentDiagram:plottingData(1).nDiagrams-1
    plottingData(i).colX = plottingData(i+1).colX;
    plottingData(i).colY = plottingData(i+1).colY;
    plottingData(i).multiplierX = plottingData(i+1).multiplierX;
    plottingData(i).multiplierY = plottingData(i+1).multiplierY;
    plottingData(i).lineColor = plottingData(i+1).lineColor;
    plottingData(i).lineType = plottingData(i+1).lineType;
    plottingData(i).lineTypeNumber = plottingData(i+1).lineTypeNumber;
    plottingData(i).smoothing = plottingData(i+1).smoothing;
    plottingData(i).originalData = plottingData(i+1).originalData;
    plottingData(i).unSampledData = plottingData(i+1).unSampledData;
    plottingData(i).adjustedData = plottingData(i+1).adjustedData;
    if isfield(plottingData, 'temporaryDiagrams')
        plottingData(i).temporaryDiagrams = plottingData(i+1).temporaryDiagrams;
    end
    if isfield(plottingData, 'markerLow')
        plottingData(i).markerLow = plottingData(i+1).markerLow;
    end
    if isfield(plottingData, 'markerHigh')
        plottingData(i).markerHigh = plottingData(i+1).markerHigh;
    end
    if isfield(plottingData, 'radii')
        plottingData(i).markerHigh = plottingData(i+1).radii;
    end
    plottingData(1).fileNames(i) = plottingData(1).fileNames(i+1);
end
plottingData(1).fileNames(plottingData(1).nDiagrams) = [];
plottingData(1).nDiagrams = plottingData(1).nDiagrams-1;

if plottingData(1).nDiagrams ~= 0
    set(handles.listbox1,'String', plottingData(1).fileNames)
    set(handles.listbox1,'Value', plottingData(1).nDiagrams)
    plottingData(1).actualExtensometer = plottingData(1).nDiagrams;
else
    set(handles.listbox1,'String', 'all diagrams deleted')
end

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes on button press in togglebutton1.
function togglebutton1_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).beingAdjusted = get(hObject,'Value');
run adjustmentUIcontrols

if plottingData(1).beingAdjusted
    plottingData(plottingData(1).currentDiagram).temporaryDiagrams =...
        [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(1).colX),...
        plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(1).colY)];
    
    maxY = max(plottingData(plottingData(1).currentDiagram).temporaryDiagrams(:,2));
    initialPositionYmarkers = [0.15*maxY, 0.5*maxY];
    [~, plottingData(1).lowIndex] = min(abs(plottingData(plottingData(1).currentDiagram).temporaryDiagrams(:,2)-initialPositionYmarkers(1)));
    [~, plottingData(1).highIndex] = min(abs(plottingData(plottingData(1).currentDiagram).temporaryDiagrams(:,2)-initialPositionYmarkers(2)));
    plottingData(plottingData(1).currentDiagram).markerLow =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,2)];
    plottingData(plottingData(1).currentDiagram).markerHigh =... 
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,2)];   
    
    lengthOfArray = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
    plottingData(1).endIndex = round(0.98*lengthOfArray);
    plottingData(plottingData(1).currentDiagram).markerEnd =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,2)];
    
    plottingData(1).shapeChanged = false;
end

plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).currentDiagram = get(hObject,'Value');

set(handles.edit1,'String',num2str(plottingData(plottingData(1).currentDiagram).lineColor(1)))
set(handles.edit2,'String',num2str(plottingData(plottingData(1).currentDiagram).lineColor(2)))
set(handles.edit3,'String',num2str(plottingData(plottingData(1).currentDiagram).lineColor(3)))
set(handles.listbox2,'Value',plottingData(plottingData(1).currentDiagram).lineTypeNumber)
set(handles.edit4,'String',num2str(plottingData(plottingData(1).currentDiagram).colX))
set(handles.edit5,'String',num2str(plottingData(plottingData(1).currentDiagram).colY))
set(handles.edit6,'String',num2str(plottingData(plottingData(1).currentDiagram).multiplierX))
set(handles.edit7,'String',num2str(plottingData(plottingData(1).currentDiagram).multiplierY))
set(handles.slider1,'Value',plottingData(plottingData(1).currentDiagram).smoothing)

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lineType = get(hObject,'Value');
switch lineType
    case 1
        plottingData(plottingData(1).currentDiagram).lineType = '-';
        plottingData(plottingData(1).currentDiagram).lineTypeNumber = 1;
    case 2
        plottingData(plottingData(1).currentDiagram).lineType = '--';
        plottingData(plottingData(1).currentDiagram).lineTypeNumber = 2;
    case 3
        plottingData(plottingData(1).currentDiagram).lineType = '-.';
        plottingData(plottingData(1).currentDiagram).lineTypeNumber = 3;
    case 4
        plottingData(plottingData(1).currentDiagram).lineType = ':';
        plottingData(plottingData(1).currentDiagram).lineTypeNumber = 4;
end

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).lineColor = ...
    [str2double(get(handles.edit1,'String')),str2double(get(handles.edit2,'String')),str2double(get(handles.edit3,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).lineColor = ...
    [str2double(get(handles.edit1,'String')),str2double(get(handles.edit2,'String')),str2double(get(handles.edit3,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).lineColor = ...
    [str2double(get(handles.edit1,'String')),str2double(get(handles.edit2,'String')),str2double(get(handles.edit3,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).colX = str2double(get(hObject,'String'));
plottingData(plottingData(1).currentDiagram).unSampledData =...
    [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colX),...
    plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colY)];
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).colY = str2double(get(hObject,'String'));
plottingData(plottingData(1).currentDiagram).unSampledData =...
    [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colX),...
    plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colY)];
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).multiplierX = str2double(get(hObject,'String'));
plottingData(plottingData(1).currentDiagram).unSampledData =...
    [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colX),...
    plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colY)];
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).multiplierY = str2double(get(hObject,'String'));
plottingData(plottingData(1).currentDiagram).unSampledData =...
    [plottingData(plottingData(1).currentDiagram).multiplierX*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colX),...
    plottingData(plottingData(1).currentDiagram).multiplierY*plottingData(plottingData(1).currentDiagram).originalData(:,plottingData(plottingData(1).currentDiagram).colY)];
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

step = -1;
plottingData(1).highIndex = max(plottingData(1).lowIndex+1,plottingData(1).highIndex+step);
plottingData(plottingData(1).currentDiagram).markerHigh =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,2)];

plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = -round(lengthOfArrays/40);
plottingData(1).highIndex = max(plottingData(1).lowIndex+1,plottingData(1).highIndex+step);
plottingData(plottingData(1).currentDiagram).markerHigh =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = 1;
plottingData(1).highIndex = min(plottingData(1).highIndex+step,lengthOfArrays);
plottingData(plottingData(1).currentDiagram).markerHigh =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = round(lengthOfArrays/40);
plottingData(1).highIndex = min(plottingData(1).highIndex+step,lengthOfArrays);
plottingData(plottingData(1).currentDiagram).markerHigh =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).highIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

step = -1;
plottingData(1).lowIndex = max(1,plottingData(1).lowIndex+step);
plottingData(plottingData(1).currentDiagram).markerLow =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = -round(lengthOfArrays/40);
plottingData(1).lowIndex = max(1,plottingData(1).lowIndex+step);
plottingData(plottingData(1).currentDiagram).markerLow =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = round(lengthOfArrays/40);
plottingData(1).lowIndex = min(plottingData(1).lowIndex+step,plottingData(1).highIndex-1);
plottingData(plottingData(1).currentDiagram).markerLow =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

step = 1;
plottingData(1).lowIndex = min(plottingData(1).lowIndex+step,plottingData(1).highIndex-1);
plottingData(plottingData(1).currentDiagram).markerLow =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).lowIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

step = -1;
plottingData(1).endIndex = max(plottingData(1).endIndex+step,plottingData(1).highIndex+1);
plottingData(plottingData(1).currentDiagram).markerEnd =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = -round(lengthOfArrays/80);
plottingData(1).endIndex = max(plottingData(1).endIndex+step,plottingData(1).highIndex+1);
plottingData(plottingData(1).currentDiagram).markerEnd =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = 1;
plottingData(1).endIndex = min(plottingData(1).endIndex+step,lengthOfArrays);
plottingData(plottingData(1).currentDiagram).markerEnd =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton15.
function pushbutton15_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

lengthOfArrays = length(plottingData(plottingData(1).currentDiagram).temporaryDiagrams);
step = round(lengthOfArrays/80);
plottingData(1).endIndex = min(plottingData(1).endIndex+step,lengthOfArrays);
plottingData(plottingData(1).currentDiagram).markerEnd =...
        [plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,1),...
        plottingData(plottingData(1).currentDiagram).temporaryDiagrams(plottingData(1).endIndex,2)];
    
plottingData(1).shapeChanged = true;
plottingData(1).justAdjusted = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).samplingDensity = str2double(get(handles.edit8,'String'));

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).makeSampling = get(handles.checkbox1,'Value');
plottingData(1).plotAverage = get(handles.checkbox1,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).makeSampling = get(handles.checkbox2,'Value');
plottingData(1).plotFill = get(handles.checkbox2,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).averageColor = [str2double(get(handles.edit9,'String')),str2double(get(handles.edit10,'String')),str2double(get(handles.edit11,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).averageColor = [str2double(get(handles.edit9,'String')),str2double(get(handles.edit10,'String')),str2double(get(handles.edit11,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit11_Callback(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).averageColor = [str2double(get(handles.edit9,'String')),str2double(get(handles.edit10,'String')),str2double(get(handles.edit11,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).fillColor = [str2double(get(handles.edit12,'String')),str2double(get(handles.edit13,'String')),str2double(get(handles.edit14,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).fillColor = [str2double(get(handles.edit12,'String')),str2double(get(handles.edit13,'String')),str2double(get(handles.edit14,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).fillColor = [str2double(get(handles.edit12,'String')),str2double(get(handles.edit13,'String')),str2double(get(handles.edit14,'String'))];

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).plotLegend = get(handles.checkbox3,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

legendLocation = get(hObject,'Value');
switch legendLocation
    case 1
        plottingData(1).legendLocation = 'southeast';
        plottingData(1).legendLocationNumber = 1;
    case 2
        plottingData(1).legendLocation = 'southwest';
        plottingData(1).legendLocationNumber = 2;
    case 3
        plottingData(1).legendLocation = 'northeast';
        plottingData(1).legendLocationNumber = 3;
    case 4
        plottingData(1).legendLocation = 'northwest';
        plottingData(1).legendLocationNumber = 4;
    case 5
        plottingData(1).legendLocation = 'west';
        plottingData(1).legendLocationNumber = 5;
    case 6
        plottingData(1).legendLocation = 'east';
        plottingData(1).legendLocationNumber = 6;
    case 7
        plottingData(1).legendLocation = 'south';
        plottingData(1).legendLocationNumber = 7;
    case 8
        plottingData(1).legendLocation = 'north';
        plottingData(1).legendLocationNumber = 8;
    case 9
        plottingData(1).legendLocation = 'westoutside';
        plottingData(1).legendLocationNumber = 9;
    case 10
        plottingData(1).legendLocation = 'eastoutside';
        plottingData(1).legendLocationNumber = 10;
    case 11
        plottingData(1).legendLocation = 'southoutside';
        plottingData(1).legendLocationNumber = 11;
    case 12
        plottingData(1).legendLocation = 'northoutside';
        plottingData(1).legendLocationNumber = 12;
end


setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).xLabel = get(handles.edit15,'String');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit16_Callback(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).yLabel = get(handles.edit16,'String');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4
handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).plotGrid = get(handles.checkbox4,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


function edit18_Callback(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).projectName = get(handles.edit18,'String');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function edit18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

tempCell = cell(size(plottingData(1).fileNames));
for i = 1:plottingData(1).nDiagrams
    dlgTitle = 'Rename the diagrams';
    prompt = sprintf('Enter the new name for diagram ''%s''',plottingData(1).fileNames{i});
    nLines = 1;
    defAns = {sprintf('%s',plottingData(1).fileNames{i})};
    tempCell{i} = char(inputdlg(prompt,dlgTitle,nLines,defAns));
end
plottingData(1).fileNames = tempCell;
set(handles.listbox1,'String',plottingData(1).fileNames);

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes

% --- Executes on button press in pushbutton17.
function pushbutton17_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).plotFigure = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');

plottingData(1).exportData = true;

setappdata(handles_mainGui, 'plottingData', plottingData);
updateAxes


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(plottingData(1).currentDiagram).smoothing = get(handles.slider1,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when selected object is changed in uipanel1.
function uipanel1_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel1 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

hSelectedObject = get(handles.uipanel1,'SelectedObject');
tagOfRadiobutton = get(hSelectedObject,'Tag');
if strcmp(tagOfRadiobutton,'radiobutton1')
    plottingData(1).printLayout = 1;
else
    plottingData(1).printLayout = 2;
end

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);


% --- Executes during object creation, after setting all properties.
function uipanel1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).autoscaleX = get(handles.checkbox6,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


function edit19_Callback(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateAxes


% --- Executes during object creation, after setting all properties.
function edit19_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateAxes


% --- Executes during object creation, after setting all properties.
function edit20_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox8.
function checkbox8_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
plottingData = getappdata(handles_mainGui, 'plottingData');
handles = getappdata(handles_mainGui, 'handles');

plottingData(1).autoscaleY = get(handles.checkbox8,'Value');

setappdata(handles_mainGui, 'plottingData', plottingData);
setappdata(handles_mainGui, 'handles', handles);

updateAxes


function edit23_Callback(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateAxes


% --- Executes during object creation, after setting all properties.
function edit23_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit24_Callback(hObject, eventdata, handles)
% hObject    handle to edit24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateAxes


% --- Executes during object creation, after setting all properties.
function edit24_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
